//---------------------------------------------------------------------------
//Socket Server Sample Program
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmMain *frmMain;
//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
//Start
void __fastcall TfrmMain::btnStartClick(TObject *Sender)
{
	if (ServerSocket1->Active == true) return;

	memoLog->Lines->Add("T[rXJn");
	memoLog->Lines->Add("");

	ServerSocket1->Port = edtPortNo->Text.ToIntDef(23456);
	ServerSocket1->Open();
}
//---------------------------------------------------------------------------
//Stop
void __fastcall TfrmMain::btnStopClick(TObject *Sender)
{
	if (ServerSocket1->Active == false) return;

	memoLog->Lines->Add("T[rX~");
	memoLog->Lines->Add("");

	ServerSocket1->Close();
}
//---------------------------------------------------------------------------
//Send
void __fastcall TfrmMain::btnSendClick(TObject *Sender)
{
	if (ServerSocket1->Active == false) return;

	memoLog->Lines->Add("--- bZ[WM ---");
	memoLog->Lines->Add(edtMsg->Text);
	memoLog->Lines->Add("");

	//Select To Name
	if (cmbTo->ItemIndex == -1) return;
	AnsiString ToName = cmbTo->Items->Strings[cmbTo->ItemIndex];

	//Send
	for (int index = 0; index < ServerSocket1->Socket->ActiveConnections; index++)
	{
		TCustomWinSocket* socket = ServerSocket1->Socket->Connections[index];
		if (socket->Connected == true && ToName == socket->RemoteHost) {
			socket->SendText(edtMsg->Text);
			break;
		}
	}
}
//---------------------------------------------------------------------------
//Connect
void __fastcall TfrmMain::ServerSocket1ClientConnect(TObject *Sender,
	  TCustomWinSocket *Socket)
{
	memoLog->Lines->Add("NCAgڑ");
	memoLog->Lines->Add("@RemoteHost = " + Socket->RemoteHost);
	memoLog->Lines->Add("@RemoteAddress = " + Socket->RemoteAddress);
	memoLog->Lines->Add("");

	Sub_ChangeToName(Socket->RemoteHost, 0);
}
//---------------------------------------------------------------------------
//Disconnect
void __fastcall TfrmMain::ServerSocket1ClientDisconnect(TObject *Sender,
	  TCustomWinSocket *Socket)
{
	memoLog->Lines->Add("NCAgؒf");
	memoLog->Lines->Add("@RemoteHost = " + Socket->RemoteHost);
	memoLog->Lines->Add("@RemoteAddress = " + Socket->RemoteAddress);
	memoLog->Lines->Add("");

	Sub_ChangeToName(Socket->RemoteHost, 1);
}
//---------------------------------------------------------------------------
//Receive
void __fastcall TfrmMain::ServerSocket1ClientRead(TObject *Sender,
	  TCustomWinSocket *Socket)
{
	memoLog->Lines->Add("--- f[^M ---");
	memoLog->Lines->Add("@RemoteHost = " + Socket->RemoteHost);
	memoLog->Lines->Add("@RemoteAddress = " + Socket->RemoteAddress);
	memoLog->Lines->Add(Socket->ReceiveText());
	memoLog->Lines->Add("");
}
//---------------------------------------------------------------------------
//Update Host Name
void __fastcall TfrmMain::Sub_ChangeToName(const AnsiString& host, int mode)
{
	int index = cmbTo->Items->IndexOf(host);
	switch (mode) {
	  case 0: if (index == -1) cmbTo->Items->Add(host);		break;	//Append
	  case 1: if (index != -1) cmbTo->Items->Delete(index);	break;	//Delete
	}
	cmbTo->ItemIndex = (cmbTo->Items->Count == 0) ? -1 : 0;
}

